/******************************************************************************
**
** AirIDS:
**    a wireless (802.11) intrusion detection system.
**
** airids.c
**
*************
**
** Copyright (c) 2001 all rights reserved, by Michael Lynn 
**
** Author: Michael Lynn abaddon@bsd.sh
**
** NOTES:
** this is still very very beta, use at your own risk...
** also most of this code is going to change soon...
** so if you dont like it bitch and ill fix the part your 
** bitching about...maybe...
**
** there is still lots more to come...
**
******************************************************************************/



#include <sys/types.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <sys/socket.h>
#include <features.h>    /* for the glibc version number */
#if __GLIBC__ >= 2 && __GLIBC_MINOR >= 1
#include <netpacket/packet.h>
#include <net/ethernet.h>     /* the L2 protocols */
#else
#include <asm/types.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>   /* The L2 protocols */
#endif
#include <getopt.h>
#include <string.h>
#include <pthread.h>

#include "airids.h"


/* this part of a hack, its gonna go real soon */
/* this is the uid we will su to after we get the sockets... */
#define SU_UID	65534

pthread_cond_t start_cond;
pthread_mutex_t start_lock;
extern int load_rules_file (const char *);
extern void process_frame (__u8 *, size_t);
extern void *front_end (void *);


/*
 * um, its usage...
 */
static void usage (const char *pname)
{
    
    fprintf(stderr, "AirIDS: a wireless (802.11) intrustion detection system. by Michael Lynn\n");
    fprintf(stderr, "\nUsage:\n\t%s [-c <cardtype>]\n", pname);
    fprintf(stderr, "\n-c : card type, either prism2 or aironet (default)\n\n");
    exit(1);
}


/*
 * parses the command line options...
 */
static void parse_opts (int argc, char **argv)
{
	char	opt;
	char	*pname = argv[0];
	

	/* set defaults */
	USE_CARD(aironet);

	opterr = 0;
	while((opt = getopt(argc, argv, "c:")) > 0) {
		switch(opt) {
			case 'c':
				if(!strcasecmp("prism2", optarg)) {
					USE_CARD(prism2);
				} else if(!strcasecmp("aironet", optarg)) {
					USE_CARD(aironet);
				} else {
					usage(pname);
				}
				break;
			default:
				usage(pname);
				break;
		}
	}
}


int main (int argc, char *argv[])
{
    int				sockfd;
    ssize_t			nbytes;
    __u8			frame[MAX_FRAME];
    struct args {
        int		argc;
        char	**argv;
    } args;
    pthread_t		thread;
    uid_t			runuid;


    if((runuid = geteuid()) != 0) {
        fprintf(stderr, "This program requires the use of privelaged socket options and as such must be run as root.\n");
        exit(1);
    }

    /* no suid in beta software */
    if(runuid != getuid()) {
        fprintf(stderr, "This is beta software, and as such we cant allow you to run it with the suid bit set, you must actualy be root!.\n");
        exit(1);
    }

    parse_opts(argc, argv);
	
    args.argc = argc;
    args.argv = argv;


    if(load_rules_file("airids.rules") < 0) {
        perror("load_rules_file");
        exit(1);
    }

    /* open the link layer socket */
    if((sockfd = get_socket()) < 0) {
        perror("get_socket");
        exit(1);
    }

    /* give up root */
    setuid(SU_UID);

    pthread_cond_init(&start_cond, NULL);
    pthread_mutex_init(&start_lock, NULL);
    pthread_mutex_lock(&start_lock);

    /* start the frontend thread */
    /* XXX - error checking!!!! */
    pthread_create(&thread, NULL, front_end, &args);

    pthread_cond_wait(&start_cond, &start_lock);
	
    while(1) {
        memset(&frame, 0, sizeof(frame));
        if((nbytes = get_frame(sockfd, &frame, sizeof(frame))) < 0) {
            perror("get_frame");
            exit(1);
        }	

        process_frame(frame, nbytes);
    }

    /* never gets here */
    close(sockfd);
    exit(0);
}

