/******************************************************************************
**
** AirIDS:
**    a wireless (802.11) intrusion detection system.
**
** aironet.c
**
*************
**
** Copyright (c) 2001 all rights reserved, by Michael Lynn 
**
** Author: Michael Lynn abaddon@bsd.sh
**
** NOTES:
** this is still very very beta, use at your own risk...
** also most of this code is going to change soon...
** so if you dont like it bitch and ill fix the part your 
** bitching about...maybe...
**
** there is still lots more to come...
**
******************************************************************************/

#include <sys/types.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <sys/socket.h>
#include <features.h>    /* for the glibc version number */
#include <netinet/in.h>
#if __GLIBC__ >= 2 && __GLIBC_MINOR >= 1
#include <netpacket/packet.h>
#include <net/ethernet.h>     /* the L2 protocols */
#else
#include <asm/types.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>   /* The L2 protocols */
#endif

#include "aironet.h"



/*** Prototypes ***/

int aironet_get_socket (void);
ssize_t aironet_get_frame (int, void *, size_t);

/******************/



/*
 * sets up the raw link layer socket for Aironet type cards...
 * returns a filedescriptor on success, -1 on error, errno is set
 */
int aironet_get_socket (void)
{
    struct sockaddr_ll	addr;
    struct ifreq		req;
    int					sockfd;


    /* open the link layer socket */
    if((sockfd = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL))) < 0) {
        return(-1);
    }

    /* get the interface index */
    memset(&req, 0, sizeof(struct ifreq));
    strcpy(req.ifr_name, "eth0");

    if(ioctl(sockfd, SIOCGIFINDEX, &req) < 0) {
        return(-2);
    }

    /* bind the socket to the interface */
    memset(&addr, 0, sizeof(struct sockaddr_ll));
    addr.sll_ifindex = req.ifr_ifindex;
    addr.sll_protocol = htons(ETH_P_ALL);
    addr.sll_family = AF_PACKET;
    if(bind(sockfd, (struct sockaddr *)&addr, sizeof(struct sockaddr_ll)) < 0) {
        perror("bind");
        return(-3);
    }

    return(sockfd);
}


/*
 * Aironet specific wrapper to the read syscall...
 */
ssize_t aironet_get_frame (int fd, void *buf, size_t count)
{
    ssize_t	nbytes;

read_again:
    if((nbytes = read(fd, buf, count)) < 0) {
        if(errno == EINTR)
        goto read_again;
    }
    return(nbytes);
}


