/******************************************************************************
**
** AirIDS:
**    a wireless (802.11) intrusion detection system.
**
** actions.h
**
*************
**
** Copyright (c) 2001 all rights reserved, by Michael Lynn 
**
** Author: Michael Lynn abaddon@bsd.sh
**
** NOTES:
** this is still very very beta, use at your own risk...
** also most of this code is going to change soon...
** so if you dont like it bitch and ill fix the part your 
** bitching about...maybe...
**
** there is still lots more to come...
**
******************************************************************************/

#ifndef __ACTIONH__
#define __ACTIONH__


struct actions {
    const char		*action_name;							/* symbolic name of the action */
    int				(*callback)(__u8 *, size_t, void *);	/* callback to the action itself */
    void			*(*init)(char *);						/* callback to the init fuction for the action */
    void			(*shutdown)(void);						/* callback to the shutdown function */
    __u8			used;									/* if the action us used in the rules file */
};

#define NUM_ACTIONS	10

#define ACTION_FATAL		-1	
#define ACTION_ERROR		0
#define ACTION_SUCCESS		1
#define ACTION_IGNORE		2
#define ACTION_SETIGNORE	3


/* external prototypes */
#ifndef __ACTIONSC__

extern void *action_init_noargs (char *);
extern void *action_init_setname (char *);
extern void action_shutdown_null (void);
extern int action_frame_info (__u8 *, size_t, void *);
extern int action_add_mac1 (__u8 *, size_t, void *);
extern int action_add_mac2 (__u8 *, size_t, void *);
extern int action_add_mac3 (__u8 *, size_t, void *);
extern int action_add_mac4 (__u8 *, size_t, void *);
extern int action_add_src (__u8 *, size_t, void *);
extern int action_remove_member (__u8 *, size_t, void *);
extern int action_ignore (__u8 *, size_t, void *);
extern int action_ignore_set (__u8 *, size_t, void *);
extern int action_insert_text (__u8 *, size_t, void *);

#endif /* #ifndef __ACTIONSC__ */


#endif /* #ifndef __ACTIONH__ */

