/******************************************************************************
**
** AirIDS:
**    a wireless (802.11) intrusion detection system.
**
** filter_engine.h
**
*************
**
** Copyright (c) 2001 all rights reserved, by Michael Lynn 
**
** Author: Michael Lynn abaddon@bsd.sh
**
** NOTES:
** this is still very very beta, use at your own risk...
** also most of this code is going to change soon...
** so if you dont like it bitch and ill fix the part your 
** bitching about...maybe...
**
** there is still lots more to come...
**
******************************************************************************/


#ifndef __STATEH__
#define __STATEH__



struct test_expr {
    __u32				offset;			/* the offset in the frame to the value to test */
    size_t				size;			/* the size of the value to compair */
    __u8				*val;			/* the value to compair against */
    __u8				mask;			/* mask value used when size one byte usualy 0*/
    __u8				op;				/* the operator to apply to the rlvalue */
    __u8				high_op;		/* the binary operator to apply to expressions of higher paren depth */
    struct test_expr	*high_expr;		/* expressions of higher paren depth */
    __u8				even_op;		/* the binary operator to apply expressions of same paren depth */
    struct test_expr	*even_expr;		/* expressions of same paren depth */
    __u8				low_op;			/* the binary operator to apply to expressions of lower paren depth */
    struct test_expr	*low_expr;		/* expressions of lower paren depth */
};

/* a rule is not really a rule but rather a grouping of test expressions */
typedef struct rule_base {
    struct test_expr	*test_exprs;				/* the test expression(s) for this rule */
    void				*action_arg;				/* pointer to action arguements */
    int (*action)(__u8 *, size_t, void *);			/* function call back to action handler */
    struct rule_base	*next_rule;					/* linkage */
} filter_rule_t;

#define MAC_ADDR_LEN	6

/* hash table of set members entry */
typedef struct set_member {
    __u8				used;					/* 1 if used 0 if not used... */
    void				*storage;				/* for future rule action use */
    __u8				mac_addr[MAC_ADDR_LEN];	/* mac address */
    struct set_member	*collition;				/* linked list of other members with same key */
} set_member_t;

/* size of member hash table, this value MUST be prime */
#define HASH_SIZE		4211

#define MAX_SETNAME		15

/* this is the rule set structure */
typedef struct rule_set {
    char				setname[MAX_SETNAME];	/* ascii name of set, from rule file */
    set_member_t		members[HASH_SIZE];		/* the hash table of mac addresses that are members */
    filter_rule_t		*rules;					/* the list of rules for this set */
    struct rule_set		*next_set;				/* next set in the linked list */
} rule_set_t;


/*** Rule Operators ***/
#define EQUAL_TO		0x00
#define NOT_EQUAL_TO	0x01
#define GREATER_THAN	0x02
#define LESS_THAN		0x04
#define IN_SET			0x08
#define NOT_IN_SET		0x10


#define OP_OR		1
#define OP_AND		2


/*** test_size's for rules ***/
#define U8		1
#define U16		2
#define U32		4
#define U64		8


#endif /* #ifndef __STATEH__ */

