/******************************************************************************
**
** AirIDS:
**    a wireless (802.11) intrusion detection system.
**
** rules_file.h
**
*************
**
** Copyright (c) 2001 all rights reserved, by Michael Lynn 
**
** Author: Michael Lynn abaddon@bsd.sh
**
** NOTES:
** this is still very very beta, use at your own risk...
** also most of this code is going to change soon...
** so if you dont like it bitch and ill fix the part your 
** bitching about...maybe...
**
** there is still lots more to come...
**
******************************************************************************/

#ifndef __CONFIG_FILEH__
#define __CONFIG_FILEH__


#define MIN(x, y)		((x < y) ? x : y)
#define MAX(x, y)		((x > y) ? x : y)

#define CHR_COMMENT		'#'
#define CHR_ENDEXPR		';'
#define CHR_RULESTART	':'
#define STR_WILDCARD	"wildcard"
#define STR_DEFINE		"define"
#define STR_SET			"set"
#define STR_LVALUE		"lvalue"
#define STR_MEMBER		"member"
#define STR_ALL			"all"
#define STR_MACRO		"macro"
#define STR_RULE		"rule"
#define STR_INSET		"in_set"
#define STR_NOTINSET	"not_in_set"
#define STR_ET			"=="
#define STR_NE			"!="
#define STR_GT			">"	
#define STR_LT			"<"	
#define STR_AND			"and"
#define STR_OR			"or"


/*
 * this is the structure for the list of preprogrammed filter
 * rules and all that...
 *
 * a value of -1 will denote that such values will need to be read 
 * from the rules file...
 */
struct rule_lvalue {
#define MAX_LV_NAME	25
    char				name[MAX_LV_NAME];	/* symbolic name for lvalue */
    __u32				offset;				/* default value of test_offset */
    __u16				size;				/* default value of test_size */
    __s16				type;				/* default data type of test_val */
    __u8				mask;				/* default test_mask value */
    __u8				shift;				/* default test_shift value */
    struct rule_lvalue	*next_lvalue;		/* linkage */
};


/* types for the lvalues */
#define TN_U8	1	/* unsigned 8 bit int */
#define TN_U16	2	/* unsigned 16 bit int */
#define TN_U32	3	/* unsigned 32 bit int */
#define TN_HEX	4	/* hex value */
#define TN_STR	5	/* string value */
#define TN_MAC	6	/* just 6 bytes in hex seperated by ':'s */

/* human reabable versions of the above */
#define TS_U8	"u8"		/* unsigned 8 bit int */
#define TS_U16	"u16"		/* unsigned 16 bit int */
#define TS_U32	"u32"		/* unsigned 32 bit int */
#define TS_HEX	"hex"		/* base 16 8 bit int */
#define TS_STR	"string"	/* collection of 8 bit ints base 256 */
#define TS_MAC	"mac"		/* 6 hex octets seperated by ':'s */


/* 
 * this is the array of old rule lvalues...
 * 
 * this is for an older version that used a 
 * staticly compiled array of these things...
 * im leaving this in here for refference...
 *
struct rule_lvalue rule_lvalues[] = {
    {"frame_control", 0, 2, RH_U16, 0, 0},
    {"version", 0, 1, RH_U8, 192, 0},
    {"type", 0, 1, RH_U8, 12, 2},
    {"subtype", 0, 1, RH_U8, 240, 4},
    {"to_ds", 1, 1, RH_U8, 1, 0},
    {"from_ds", 1, 1, RH_U8, 2, 1},
    {"more_frag", 1, 1, RH_U8, 4, 2},
    {"retry", 1, 1, RH_U8, 8, 3},
    {"pwr_man", 1, 1, RH_U8, 16, 4},
    {"more_data", 1, 1, RH_U8, 32, 5},
    {"wep", 1, 1, RH_U8, 64, 6},
    {"order", 1, 1, RH_U8, 128, 7},
    {"duration_id", 2, 2, RH_U16, 0, 0},
    {"mac1", 3, 6, RH_MAC, 0, 0},
    {"mac2", 10, 6, RH_MAC, 0, 0},
    {"mac3", 17, 6, RH_MAC, 0, 0},
    {"seq_control", 24, 2, RH_U16, 0, 0},
    {"frag_num", 24, 1, RH_U8, 240, 0},
    {"seq_num", 24, 2, RH_U16, 4095, 0},
    {"mac4", 26, 6, RH_MAC, 0, 0}
};
*/



#endif /* #ifndef __CONFIG_FILEH__ */
