/******************************************************************************
**
** AirIDS:
**    a wireless (802.11) intrusion detection system.
**
** prism2.c
**
*************
**
** Copyright (c) 2001 all rights reserved, by Michael Lynn 
**
** Author: Michael Lynn abaddon@bsd.sh
**
** NOTES:
** this is still very very beta, use at your own risk...
** also most of this code is going to change soon...
** so if you dont like it bitch and ill fix the part your 
** bitching about...maybe...
**
** there is still lots more to come...
**
******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>
#include <asm/types.h>
#include <linux/netlink.h>
#include <netinet/in.h>
#include <errno.h>
#include <limits.h>
#include <getopt.h>

#include "prism2.h"


/*** Prototypes ***/

int prism2_get_socket (void);
ssize_t prism2_get_frame (int, void *, size_t);

/******************/


/*
 * Prism2 specific:
 * bind the netlink socket to the interface and returns a
 * file descripter to the new socket...
 * calls perror and exits on error...
 */
int prism2_get_socket (void)
{
    int		fd;						/* netlink socket file descriptor */
    struct	sockaddr_nl sockAddr;	/* netlink socket address */


    if((fd = socket(PF_NETLINK, SOCK_RAW, MCAST_GRP_SNIFF)) < 0) {
        return(-1);
    }

    memset(&sockAddr, 0, sizeof (struct sockaddr_nl));
    sockAddr.nl_family = (sa_family_t) PF_NETLINK;
    sockAddr.nl_pid = (unsigned int) getpid();
    sockAddr.nl_groups = MCAST_GRP_SNIFF;

    if(bind(fd, (struct sockaddr *)&sockAddr, sizeof(struct sockaddr_nl)) < 0) {
        return(-2);
    }

    return(fd);
}



/*
 * Prism2 specific wrapper for the read syscall...
 * reads from the netlink socket and then strips the
 * prism2 netlink header from the frame, and returns
 * the size of that buffer...
 */
ssize_t prism2_get_frame (int fd, void *buf, size_t count)
{
    ssize_t	nbytes;
    void	*tmp;


    if((tmp = malloc(count + sizeof(struct prism_hdr))) == NULL) {
        return(-1);
    }

read_again:
    if((nbytes = read(fd, tmp, count)) < 0) {
        if(errno == EINTR)
            goto read_again;
        return(-1);
    }

    if(nbytes < sizeof(struct prism_hdr)) {
        return(-1);
    }

    nbytes -= sizeof(struct prism_hdr);

    memcpy(buf, (tmp + sizeof(struct prism_hdr)), nbytes);
    free(tmp);
    return(nbytes);
}


